import org.jboss.byteman.contrib.bmunit.BMNGRunner;
import org.jboss.byteman.contrib.bmunit.BMRule;
import org.jboss.byteman.contrib.bmunit.BMScript;
import org.testng.annotations.Test;

import java.net.URISyntaxException;

public class SimpleTest extends BMNGRunner {

    Simple s = new Simple();

    @Test
    public void testOKURI() throws URISyntaxException {
        s.newOKURI();
    }

    @Test(expectedExceptions = URISyntaxException.class)
    public void testFailURI() throws URISyntaxException {
        s.newFailURI();
    }

    @BMRule(
            name = "throw URI exception",
            targetClass = "java.net.URI",
            targetMethod = "<init>(String)",
            action = "throw new java.net.URISyntaxException(\"bad bad URI!\")"
    )
    @Test(expectedExceptions = URISyntaxException.class)
    public void testDirectBMRuleOKURI() throws URISyntaxException {
        new java.net.URI("http://www.google.com/");
    }

    @BMScript(value = "uri-exception", dir = "src/test/scripts")
    @Test(expectedExceptions = URISyntaxException.class)
    public void testDirectBMScriptOKURI() throws URISyntaxException {
        new java.net.URI("http://www.google.com/");
    }

    @BMRule(
            name = "throw URI exception",
            targetClass = "java.net.URI",
            targetMethod = "<init>(String)",
            action = "throw new java.net.URISyntaxException(\"bad bad URI!\")"
    )
    @Test(expectedExceptions = URISyntaxException.class)
    public void testBMRuleOKURI() throws URISyntaxException {
        s.newOKURI();
    }

    @BMScript(value = "uri-exception", dir = "src/test/scripts")
    @Test(expectedExceptions = URISyntaxException.class)
    public void testBMScriptOKURI() throws URISyntaxException {
        s.newOKURI();
    }



}
